diff --git a/drivers/usb/function/usb_function.h b/drivers/usb/function/usb_function.h
index d06e5c9..a953021 100644
--- a/drivers/usb/function/usb_function.h
+++ b/drivers/usb/function/usb_function.h
@@ -75,7 +75,7 @@ struct usb_function
 	**
 	** might be a good place to allocate some usb_request objects
 	*/
-	void (*bind)(struct usb_endpoint **ept, void *context);
+	int (*bind)(struct usb_endpoint **ept, void *context);
 
 	/* unbind() is called when the function is being removed.
 	** it is illegal to call and usb_ept_* hooks at this point
@@ -138,13 +138,12 @@ struct usb_function
 	struct usb_descriptor_header **cdc_desc; 
 };
 
-unsigned return_usb_function_enabled(const char *function);
+extern unsigned return_usb_function_enabled(const char *function);
+extern int usb_function_register(struct usb_function *driver);
 
-int usb_function_register(struct usb_function *driver);
-
-int usb_function_enable(const char *function, int enable);
-struct usb_fi_ept *get_ept_info(const char *function);
-struct usb_interface_descriptor *get_ifc_desc(const char *function);
+extern int usb_function_enable(const char *function, int enable);
+extern struct usb_fi_ept *get_ept_info(const char *function);
+extern struct usb_interface_descriptor *get_ifc_desc(const char *function);
 
 /* Allocate a USB request.
 ** Must be called from a context that can sleep.
@@ -152,15 +151,15 @@ struct usb_interface_descriptor *get_ifc_desc(const char *function);
 ** you and free'd when the request is free'd.  Otherwise
 ** it is your responsibility to provide.
 */
-struct usb_request *usb_ept_alloc_req(struct usb_endpoint *ept, unsigned bufsize);
-void usb_ept_free_req(struct usb_endpoint *ept, struct usb_request *req);
+extern struct usb_request *usb_ept_alloc_req(struct usb_endpoint *ept, unsigned bufsize);
+extern void usb_ept_free_req(struct usb_endpoint *ept, struct usb_request *req);
 
 /* safely callable from any context
 ** returns 0 if successfully queued and sets req->status = -EBUSY
 ** req->status will change to a different value upon completion
 ** (0 for success, -EIO, -ENODEV, etc for error)
 */
-int usb_ept_queue_xfer(struct usb_endpoint *ept, struct usb_request *req);
-int usb_ept_flush(struct usb_endpoint *ept);
-int usb_ept_get_max_packet(struct usb_endpoint *ept);
+extern int usb_ept_queue_xfer(struct usb_endpoint *ept, struct usb_request *req);
+extern int usb_ept_flush(struct usb_endpoint *ept);
+extern int usb_ept_get_max_packet(struct usb_endpoint *ept);
 #endif
diff --git a/drivers/usb/function/zero.c b/drivers/usb/function/zero.c
index 5286ff5..df16e90 100644
--- a/drivers/usb/function/zero.c
+++ b/drivers/usb/function/zero.c
@@ -31,23 +31,31 @@ struct zero_context
 
 static struct zero_context _context;
 
-static void zero_bind(struct usb_endpoint **ept, void *_ctxt)
+static int zero_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct zero_context *ctxt = _ctxt;
 	ctxt->in = ept[0];
-	printk(KERN_INFO "zero_bind() %p\n", ctxt->in);
 
-	ctxt->req0 = usb_ept_alloc_req(ctxt->in, 4096);
-	ctxt->req1 = usb_ept_alloc_req(ctxt->in, 4096);
+	if ((ctxt->req0 = usb_ept_alloc_req(ctxt->in, 4096)) == NULL)
+		goto req0_fail;
+	if ((ctxt->req1 = usb_ept_alloc_req(ctxt->in, 4096)) == NULL)
+		goto req1_fail;
 
 	memset(ctxt->req0->buf, 0, 4096);
 	memset(ctxt->req1->buf, 0, 4096);
+
+	return 0;
+
+req1_fail:
+	usb_ept_free_req(ctxt->in, ctxt->req0);
+req0_fail:
+	printk("ums_bind() could not allocate requests\n");
+	return -1;
 }
 
 static void zero_unbind(void *_ctxt)
 {
 	struct zero_context *ctxt = _ctxt;
-	printk(KERN_INFO "null_unbind()\n");
 	if (ctxt->req0) {
 		usb_ept_free_req(ctxt->in, ctxt->req0);
 		ctxt->req0 = 0;
@@ -64,7 +72,6 @@ static void zero_queue_in(struct zero_context *ctxt, struct usb_request *req);
 static void zero_in_complete(struct usb_endpoint *ept, struct usb_request *req)
 {
 	struct zero_context *ctxt = req->context;
-	unsigned char *data = req->buf;
 
 	if (req->status != -ENODEV)
 		zero_queue_in(ctxt, req);
@@ -112,11 +119,7 @@ static struct usb_function usb_func_zero = {
 	.ifc_num = 1,
 };
 
-static int __init zero_init(void)
+void zero_init(void)
 {
-	printk(KERN_INFO "zero_init()\n");
-	usb_function_register(&usb_func_zero);
-	return 0;
+       usb_function_register(&usb_func_zero);
 }
-
-module_init(zero_init);
diff --git a/drivers/usb/gadget/msm72k_udc.c b/drivers/usb/gadget/msm72k_udc.c
index 09f1838..894d2b2 100644
--- a/drivers/usb/gadget/msm72k_udc.c
+++ b/drivers/usb/gadget/msm72k_udc.c
@@ -16,6 +16,8 @@
  *
  */
 
+#define DEBUG 1
+
 #include <linux/init.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
@@ -41,7 +43,6 @@
 
 static const char driver_name[] = "msm72k_udc";
 
-/* #define DEBUG */
 /* #define VERBOSE */
 #include <mach/msm_hsusb_hw.h>
 
@@ -123,6 +124,7 @@ static void usb_do_work(struct work_struct *w);
 #define USB_FLAG_VBUS_ONLINE    0x0002
 #define USB_FLAG_VBUS_OFFLINE   0x0004
 #define USB_FLAG_RESET          0x0008
+#define USB_FLAG_SHUTDOWN       0x0010
 
 struct usb_info {
 	/* lock for register/queue/device state changes */
@@ -160,6 +162,7 @@ struct usb_info {
 
 	int *phy_init_seq;
 	void (*phy_reset)(void);
+        void (*phy_shutdown)(void);
 
 	struct work_struct work;
 	unsigned phy_status;
@@ -173,6 +176,8 @@ struct usb_info {
 
 	struct clk *clk;
 	struct clk *pclk;
+
+	struct dentry *dent;
 };
 
 static const struct usb_ep_ops msm72k_ep_ops;
@@ -755,6 +760,9 @@ static irqreturn_t usb_interrupt(int irq, void *data)
 				ui->driver->disconnect(&ui->gadget);
 			}
 		}
+
+		if (msm_usb_get_connect_status() == 0)
+			msm_usb_set_connect_status(1);
 	}
 
 	if (n & STS_SLI)
@@ -776,29 +784,6 @@ static irqreturn_t usb_interrupt(int irq, void *data)
 	return IRQ_HANDLED;
 }
 
-static void usb_prepare(struct usb_info *ui)
-{
-	spin_lock_init(&ui->lock);
-
-	memset(ui->buf, 0, 4096);
-	ui->head = (void *) (ui->buf + 0);
-
-	/* only important for reset/reinit */
-	memset(ui->ept, 0, sizeof(ui->ept));
-	ui->next_item = 0;
-	ui->next_ifc_num = 0;
-
-	init_endpoints(ui);
-
-	ui->ep0in.ep.maxpacket = 64;
-	ui->ep0out.ep.maxpacket = 64;
-
-	ui->setup_req =
-		usb_ept_alloc_req(&ui->ep0in, SETUP_BUF_SIZE, GFP_KERNEL);
-
-	INIT_WORK(&ui->work, usb_do_work);
-}
-
 static void usb_suspend_phy(struct usb_info *ui)
 {
 	/* clear VBusValid and SessionEnd rising interrupts */
@@ -835,8 +820,8 @@ static void usb_reset(struct usb_info *ui)
 	if (ui->phy_reset)
 		ui->phy_reset();
 
-	/* INCR4 BURST mode */
-	writel(0x01, USB_SBUSCFG);
+        /* INCR8 BURST mode */
+        writel(0x02, USB_SBUSCFG);      /*boost performance to fix CRC error.*/
 
 	/* select DEVICE mode */
 	writel(0x12, USB_USBMODE);
@@ -874,36 +859,31 @@ static void usb_reset(struct usb_info *ui)
 	spin_unlock_irqrestore(&ui->lock, flags);
 }
 
-static void usb_start(struct usb_info *ui)
+static void usb_do_work_start(struct usb_info *ui)
 {
 	unsigned long flags;
 
 	spin_lock_irqsave(&ui->lock, flags);
-	ui->flags |= USB_FLAG_START;
-	schedule_work(&ui->work);
+	if (!(ui->flags & USB_FLAG_SHUTDOWN)) {
+		ui->flags |= USB_FLAG_START;
+		schedule_work(&ui->work);
+	}
 	spin_unlock_irqrestore(&ui->lock, flags);
 }
 
 static struct usb_info *the_usb_info;
 
-static int usb_free(struct usb_info *ui, int ret)
+static void usb_do_work_stop(struct usb_info *ui)
 {
-	INFO("usb_free(%d)\n", ret);
+	unsigned long flags;
 
-	if (ui->irq)
-		free_irq(ui->irq, 0);
-	if (ui->pool)
-		dma_pool_destroy(ui->pool);
-	if (ui->dma)
-		dma_free_coherent(&ui->pdev->dev, 4096, ui->buf, ui->dma);
-	if (ui->addr)
-		iounmap(ui->addr);
-	if (ui->clk)
-		clk_put(ui->clk);
-	if (ui->pclk)
-		clk_put(ui->pclk);
-	kfree(ui);
-	return ret;
+	spin_lock_irqsave(&ui->lock, flags);
+	ui->flags |= USB_FLAG_SHUTDOWN;
+	spin_unlock_irqrestore(&ui->lock, flags);
+
+	// FIXME: wait for it to shutdown?
+//	while(ui->state != USB_STATEg865_SHUTDOWN)
+//		mdelay(1);
 }
 
 static void usb_do_work_check_vbus(struct usb_info *ui)
@@ -932,7 +912,7 @@ static void usb_do_work(struct work_struct *w)
 		spin_unlock_irqrestore(&ui->lock, iflags);
 
 		/* give up if we have nothing to do */
-		if (flags == 0)
+		if ((flags == 0) || (flags & USB_FLAG_SHUTDOWN))
 			break;
 
 		switch (ui->state) {
@@ -956,6 +936,10 @@ static void usb_do_work(struct work_struct *w)
 
 				/* synchronize with irq context */
 				spin_lock_irqsave(&ui->lock, iflags);
+
+				if (msm_usb_get_connect_status() == 1)
+					msm_usb_set_connect_status(0);
+
 				ui->running = 0;
 				ui->online = 0;
 				msm72k_pullup(&ui->gadget, 0);
@@ -1009,14 +993,15 @@ static void usb_do_work(struct work_struct *w)
  * This is called from htc_battery.c and board-halibut.c
  * WARNING - this can get called before this driver is initialized.
  */
-void msm_hsusb_set_vbus_state(int online)
+static void usb_set_vbus_state(int online)
 {
 	unsigned long flags;
 	struct usb_info *ui = the_usb_info;
 
 	if (ui) {
 		spin_lock_irqsave(&ui->lock, flags);
-		if (vbus != online) {
+
+		if ((vbus != online) && (!(ui->flags & USB_FLAG_SHUTDOWN))) {
 			vbus = online;
 			if (online)
 				ui->flags |= USB_FLAG_VBUS_ONLINE;
@@ -1033,10 +1018,8 @@ void msm_hsusb_set_vbus_state(int online)
 
 #if defined(CONFIG_DEBUG_FS)
 
-void usb_function_reenumerate(void)
+void usb_function_reenumerate(struct usb_info *ui)
 {
-	struct usb_info *ui = the_usb_info;
-
 	/* disable and re-enable the D+ pullup */
 	INFO("msm72k_udc: disable pullup\n");
 	writel(0x00080000, USB_USBCMD);
@@ -1121,7 +1104,9 @@ static ssize_t debug_write_reset(struct file *file, const char __user *buf,
 static ssize_t debug_write_cycle(struct file *file, const char __user *buf,
 				 size_t count, loff_t *ppos)
 {
-	usb_function_reenumerate();
+	struct usb_info *ui = file->private_data;
+
+	usb_function_reenumerate(ui);
 	return count;
 }
 
@@ -1148,17 +1133,25 @@ const struct file_operations debug_cycle_ops = {
 
 static void usb_debugfs_init(struct usb_info *ui)
 {
-	struct dentry *dent;
-	dent = debugfs_create_dir("usb", 0);
-	if (IS_ERR(dent))
+	ui->dent = debugfs_create_dir("usb", 0);
+	if (IS_ERR(ui->dent)) {
+		ui->dent = NULL;
 		return;
+	}
+
+	debugfs_create_file("status", 0444, ui->dent, ui, &debug_stat_ops);
+	debugfs_create_file("reset", 0222, ui->dent, ui, &debug_reset_ops);
+	debugfs_create_file("cycle", 0222, ui->dent, ui, &debug_cycle_ops);
+}
 
-	debugfs_create_file("status", 0444, dent, ui, &debug_stat_ops);
-	debugfs_create_file("reset", 0222, dent, ui, &debug_reset_ops);
-	debugfs_create_file("cycle", 0222, dent, ui, &debug_cycle_ops);
+static void usb_debugfs_shutdown(struct usb_info *ui)
+{
+	if (ui->dent)
+		debugfs_remove_recursive(ui->dent);
 }
 #else
 static void usb_debugfs_init(struct usb_info *ui) {}
+static void usb_debugfs_shutdown(struct usb_info *ui) {}
 #endif
 
 static int
@@ -1311,7 +1304,7 @@ static int msm72k_get_frame(struct usb_gadget *_gadget)
 /* VBUS reporting logically comes from a transceiver */
 static int msm72k_udc_vbus_session(struct usb_gadget *_gadget, int is_active)
 {
-	msm_hsusb_set_vbus_state(is_active);
+	usb_set_vbus_state(is_active);
 	return 0;
 }
 
@@ -1335,16 +1328,69 @@ static const struct usb_gadget_ops msm72k_ops = {
 	.pullup		= msm72k_pullup,
 };
 
-static ssize_t usb_remote_wakeup(struct device *dev,
-		struct device_attribute *attr, const char *buf, size_t count)
+static int msm72k_remove(struct platform_device *pdev)
 {
-	struct usb_info *ui = the_usb_info;
+	struct usb_info *ui = platform_get_drvdata(pdev);
 
-	msm72k_wakeup(&ui->gadget);
+	printk("REMOVE0\n");
+	msm_hsusb_set_vbus_state_notifier(NULL);
+	printk("REMOVE1\n");
+	usb_do_work_stop(ui);
 
-	return count;
+	printk("REMOVE2\n");
+
+	// FIXME: hangs here
+	writel(readl(USB_ENDPTSETUPSTAT), USB_ENDPTSETUPSTAT);
+	writel(readl(USB_ENDPTCOMPLETE), USB_ENDPTCOMPLETE);
+	writel(0xffffffff, USB_ENDPTFLUSH);
+	writel(0, USB_ENDPTCTRL(1));
+
+	if (ui->online != 0) {
+		flush_all_endpoints(ui);
+		ui->online = 0;
+	}
+	
+	printk("REMOVE3X\n");
+
+	if (ui->driver) {
+		printk(KERN_INFO "usb: notify offline\n");
+		ui->driver->disconnect(&ui->gadget);
+	}
+
+	printk("REMOVE3\n");
+
+	/* reset the controller */
+	writel(2, USB_USBCMD);
+	msleep(10);
+
+	printk("REMOVE4\n");
+
+	if (ui->phy_shutdown)
+		ui->phy_shutdown();
+	if (ui->setup_req)
+		do_free_req(ui, to_msm_request(ui->setup_req));
+	if (ui->irq)
+		free_irq(ui->irq, ui);
+	if (ui->pool)
+		dma_pool_destroy(ui->pool);
+	if (ui->dma)
+		dma_free_coherent(&ui->pdev->dev, 4096, ui->buf, ui->dma);
+	if (ui->addr)
+		iounmap(ui->addr);
+	if (ui->clk)
+		clk_put(ui->clk);
+	if (ui->pclk)
+		clk_put(ui->pclk);
+
+	printk("REMOVE5\n");
+	
+	usb_debugfs_shutdown(ui);
+
+	printk("REMOVE6\n");
+
+	kfree(ui);
+	return 0;
 }
-static DEVICE_ATTR(wakeup, S_IWUSR, 0, usb_remote_wakeup);
 
 static int msm72k_probe(struct platform_device *pdev)
 {
@@ -1352,66 +1398,114 @@ static int msm72k_probe(struct platform_device *pdev)
 	struct usb_info *ui;
 	int irq;
 	int ret;
-
+	
 	INFO("msm72k_probe\n");
 	ui = kzalloc(sizeof(struct usb_info), GFP_KERNEL);
-	if (!ui)
+	if (!ui) {
+		dev_dbg(&pdev->dev, "usb_info alloc failed\n");
 		return -ENOMEM;
+	}
 
 	ui->pdev = pdev;
+	platform_set_drvdata(pdev, ui);
+	the_usb_info = ui;
 
 	if (pdev->dev.platform_data) {
 		struct msm_hsusb_platform_data *pdata = pdev->dev.platform_data;
 		ui->phy_reset = pdata->phy_reset;
+		ui->phy_shutdown = pdata->phy_shutdown;
 		ui->phy_init_seq = pdata->phy_init_seq;
 	}
 
 	irq = platform_get_irq(pdev, 0);
 	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
-	if (!res || (irq < 0))
-		return usb_free(ui, -ENODEV);
-
+	if (!res || (irq < 0)) {
+		dev_dbg(&pdev->dev, "failed to get platform resources\n");
+		msm72k_remove(pdev);
+		return -ENODEV;
+	}
+	
 	ui->addr = ioremap(res->start, 4096);
-	if (!ui->addr)
-		return usb_free(ui, -ENOMEM);
-
+	if (!ui->addr) {
+		dev_dbg(&pdev->dev, "failed to map memory\n");
+		msm72k_remove(pdev);
+		return -ENOMEM;
+	}
+	
 	ui->buf = dma_alloc_coherent(&pdev->dev, 4096, &ui->dma, GFP_KERNEL);
-	if (!ui->buf)
-		return usb_free(ui, -ENOMEM);
+	if (!ui->buf) {
+		dev_dbg(&pdev->dev, "failed alloc buffer\n");
+		msm72k_remove(pdev);
+		return -ENOMEM;
+	}
 
 	ui->pool = dma_pool_create("msm72k_udc", NULL, 32, 32, 0);
-	if (!ui->pool)
-		return usb_free(ui, -ENOMEM);
-
+	if (!ui->pool) {
+		dev_dbg(&pdev->dev, "failed to create DMA pool\n");
+		msm72k_remove(pdev);
+		return -ENOMEM;
+	}
+	
 	INFO("msm72k_probe() io=%p, irq=%d, dma=%p(%x)\n",
 	       ui->addr, irq, ui->buf, ui->dma);
 
 	ui->clk = clk_get(&pdev->dev, "usb_hs_clk");
-	if (IS_ERR(ui->clk))
-		return usb_free(ui, PTR_ERR(ui->clk));
+	if (IS_ERR(ui->clk)) {
+		dev_dbg(&pdev->dev, "failed to get usb_hs_clk\n");
+		msm72k_remove(pdev);
+		return PTR_ERR(ui->clk);
+	}
 
 	ui->pclk = clk_get(&pdev->dev, "usb_hs_pclk");
-	if (IS_ERR(ui->pclk))
-		return usb_free(ui, PTR_ERR(ui->pclk));
+	if (IS_ERR(ui->pclk)) {
+		dev_dbg(&pdev->dev, "failed to get usb_hs_pclk\n");
+		msm72k_remove(pdev);
+		return PTR_ERR(ui->pclk);
+	}
 
 	ret = request_irq(irq, usb_interrupt, 0, pdev->name, ui);
-	if (ret)
-		return usb_free(ui, ret);
+	if (ret) {
+		dev_dbg(&pdev->dev, "failed to acquire IRQ\n");
+		msm72k_remove(pdev);
+		return ret;
+	}
 	enable_irq_wake(irq);
 	ui->irq = irq;
-
+	
 	ui->gadget.ops = &msm72k_ops;
 	ui->gadget.is_dualspeed = 1;
 	device_initialize(&ui->gadget.dev);
 	strcpy(ui->gadget.dev.bus_id, "gadget");
 	ui->gadget.dev.parent = &pdev->dev;
 	ui->gadget.dev.dma_mask = pdev->dev.dma_mask;
+	
+	spin_lock_init(&ui->lock);
 
-	the_usb_info = ui;
+	memset(ui->buf, 0, 4096);
+	ui->head = (void *) (ui->buf + 0);
 
-	usb_debugfs_init(ui);
+	/* only important for reset/reinit */
+	memset(ui->ept, 0, sizeof(ui->ept));
+	ui->next_item = 0;
+	ui->next_ifc_num = 0;
+	
+	init_endpoints(ui);
+
+	ui->ep0in.ep.maxpacket = 64;
+	ui->ep0out.ep.maxpacket = 64;
+
+	ui->setup_req =
+		usb_ept_alloc_req(&ui->ep0in, SETUP_BUF_SIZE, GFP_KERNEL);
+	if (!ui->setup_req) {
+		dev_dbg(&pdev->dev, "failed to alloc setup_req space\n");
+		msm72k_remove(pdev);
+		return -ENOMEM;		
+	}
+
+	INIT_WORK(&ui->work, usb_do_work);
 
-	usb_prepare(ui);
+	usb_debugfs_init(ui);
+	msm_hsusb_set_vbus_state_notifier(&usb_set_vbus_state);
 
 	return 0;
 }
@@ -1464,14 +1558,9 @@ int usb_gadget_register_driver(struct usb_gadget_driver *driver)
 		goto fail;
 	}
 
-	/* create sysfs node for remote wakeup */
-	retval = device_create_file(&ui->gadget.dev, &dev_attr_wakeup);
-	if (retval != 0)
-		INFO("failed to create sysfs entry: (wakeup) error: (%d)\n",
-					retval);
 	INFO("msm72k_udc: registered gadget driver '%s'\n",
 			driver->driver.name);
-	usb_start(ui);
+	usb_do_work_start(ui);
 
 	return 0;
 
@@ -1491,7 +1580,6 @@ int usb_gadget_unregister_driver(struct usb_gadget_driver *driver)
 	if (!driver || driver != dev->driver || !driver->unbind)
 		return -EINVAL;
 
-	device_remove_file(&dev->gadget.dev, &dev_attr_wakeup);
 	driver->unbind(&dev->gadget);
 	dev->gadget.dev.driver = NULL;
 	dev->driver = NULL;
@@ -1506,6 +1594,7 @@ EXPORT_SYMBOL(usb_gadget_unregister_driver);
 
 static struct platform_driver usb_driver = {
 	.probe = msm72k_probe,
+	.remove = msm72k_remove,
 	.driver = { .name = "msm_hsusb", },
 };
 
diff --git a/drivers/usb/host/Kconfig b/drivers/usb/host/Kconfig
index 228797e..caed838 100644
--- a/drivers/usb/host/Kconfig
+++ b/drivers/usb/host/Kconfig
@@ -88,6 +88,13 @@ config USB_EHCI_FSL
 	---help---
 	  Variation of ARC USB block used in some Freescale chips.
 
+config USB_EHCI_MSM7201
+	bool "Support for Qualcomm MSM7201 on-chip EHCI USB controller"
+	depends on USB_EHCI_HCD && (ARCH_MSM7XXX || ARCH_MSM || ARCH_MSM7X00A) && (!USB_FUNCTION)
+	select USB_EHCI_ROOT_HUB_TT
+	---help---
+	  Variation of ARC USB block used in Qualcomm MSM7201 chips.
+
 config USB_EHCI_HCD_PPC_OF
 	bool "EHCI support for PPC USB controller on OF platform bus"
 	depends on USB_EHCI_HCD && PPC_OF
diff --git a/drivers/usb/host/ehci-hcd.c b/drivers/usb/host/ehci-hcd.c
index 8409e07..47be567 100644
--- a/drivers/usb/host/ehci-hcd.c
+++ b/drivers/usb/host/ehci-hcd.c
@@ -1040,6 +1040,11 @@ MODULE_LICENSE ("GPL");
 #define	PLATFORM_DRIVER		ixp4xx_ehci_driver
 #endif
 
+#if defined(CONFIG_ARCH_MSM7XXX) || defined(CONFIG_ARCH_MSM) || defined(ARCH_MSM7X00A)
+#include "ehci-msm7201.c"
+#define	PLATFORM_DRIVER		ehci_msm7201_driver
+#endif
+
 #if !defined(PCI_DRIVER) && !defined(PLATFORM_DRIVER) && \
     !defined(PS3_SYSTEM_BUS_DRIVER) && !defined(OF_PLATFORM_DRIVER)
 #error "missing bus glue for ehci-hcd"
diff --git a/drivers/usb/host/ehci-msm7201.c b/drivers/usb/host/ehci-msm7201.c
new file mode 100644
index 0000000..4e6fe78
--- /dev/null
+++ b/drivers/usb/host/ehci-msm7201.c
@@ -0,0 +1,319 @@
+/*
+ * Copyright (c) 2010 Andrew de Quincey
+ *
+ * (heavily) based on ehci-fsl.c, which is:
+ * 
+ * Copyright (c) 2005 MontaVista Software
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Ported to 834x by Randy Vinson <rvinson@mvista.com> using code provided
+ * by Hunter Wu.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/clk.h>
+#include <mach/msm_hsusb.h>
+
+#include "ehci-msm7201.h"
+
+static void ulpi_write(struct usb_hcd *hcd, unsigned val, unsigned reg)
+{
+	unsigned timeout = 10000;
+
+	/* initiate write operation */
+	writel(ULPI_RUN | ULPI_WRITE |
+	       ULPI_ADDR(reg) | ULPI_DATA(val),
+	       USB_ULPI_VIEWPORT);
+
+	/* wait for completion */
+	while ((readl(USB_ULPI_VIEWPORT) & ULPI_RUN) && (--timeout)) ;
+
+	if (timeout == 0)
+		printk(KERN_WARNING "%s: timeout: reg: 0x%X, var: 0x%X\n",
+		__func__, reg, val);
+}
+
+static void msm7201_setup_phy(struct usb_hcd *hcd)
+{
+	struct msm7201_usb_priv *msm7201 = hcd_to_msm7201(hcd);
+
+  	int *seq = msm7201->phy_init_seq;
+
+	if (!seq)
+		return;
+
+	while (seq[0] >= 0) {
+		ulpi_write(hcd, seq[0], seq[1]);
+		seq += 2;
+	}
+}
+
+static void msm7201_shutdown_phy(struct usb_hcd *hcd)
+{
+	struct msm7201_usb_priv *msm7201 = hcd_to_msm7201(hcd);
+
+	if (msm7201->phy_shutdown)
+		msm7201->phy_shutdown();
+	
+	/* disable interface protect circuit to drop current consumption */
+	ulpi_write(hcd, (1 << 7), 0x08);
+	/* clear the SuspendM bit -> suspend the PHY */
+	ulpi_write(hcd, 1 << 6, 0x06);
+}
+
+static void msm7201_usb_setup(struct usb_hcd *hcd)
+{
+	struct msm7201_usb_priv *msm7201 = hcd_to_msm7201(hcd);
+	int i;
+
+	/* INCR8 BURST mode */
+	writel(0x02, USB_SBUSCFG);	/*boost performance to fix CRC error.*/
+
+	/* select ULPI phy */
+	writel(0x80000000, USB_PORTSC);
+
+	if (msm7201->phy_reset)
+		msm7201->phy_reset();
+	msm7201_setup_phy(hcd);
+}
+
+/* called after powerup, by probe or system-pm "wakeup" */
+static int ehci_msm7201_reinit(struct ehci_hcd *ehci)
+{
+	msm7201_usb_setup(ehci_to_hcd(ehci));
+	ehci_port_power(ehci, 0);
+
+	return 0;
+}
+
+/* called during probe() after chip reset completes */
+static int ehci_msm7201_setup(struct usb_hcd *hcd)
+{
+	struct ehci_hcd *ehci = hcd_to_ehci(hcd);
+	int retval;
+
+	/* EHCI registers start at offset 0x100 */
+	ehci->caps = hcd->regs + 0x100;
+	ehci->regs = hcd->regs + 0x100 +
+	    HC_LENGTH(ehci_readl(ehci, &ehci->caps->hc_capbase));
+
+	/* configure other settings */
+	ehci->hcs_params = ehci_readl(ehci, &ehci->caps->hcs_params);
+	hcd->has_tt = 1;
+	ehci->sbrn = 0x20;
+
+	/* reset and halt controller */
+	ehci_reset(ehci);
+	retval = ehci_halt(ehci);
+	if (retval)
+		return retval;
+
+	/* data structure init */
+	retval = ehci_init(hcd);
+	if (retval)
+		return retval;
+        
+	ehci_reset(ehci);
+
+	retval = ehci_msm7201_reinit(ehci);
+	return retval;
+}
+
+static const struct hc_driver ehci_msm7201_hc_driver = {
+	.description = hcd_name,
+	.product_desc = "Qualcomm MSM7201 On-Chip EHCI Host Controller",
+	.hcd_priv_size = sizeof(struct ehci_hcd) + sizeof(struct msm7201_usb_priv),
+
+	/*
+	 * generic hardware linkage
+	 */
+	.irq = ehci_irq,
+	.flags = HCD_USB2 | HCD_MEMORY | HCD_LOCAL_MEM,
+
+	/*
+	 * basic lifecycle operations
+	 */
+	.reset = ehci_msm7201_setup,
+	.start = ehci_run,
+	.stop = ehci_stop,
+	.shutdown = ehci_shutdown,
+
+	/*
+	 * managing i/o requests and associated device resources
+	 */
+	.urb_enqueue = ehci_urb_enqueue,
+	.urb_dequeue = ehci_urb_dequeue,
+	.endpoint_disable = ehci_endpoint_disable,
+
+	/*
+	 * scheduling support
+	 */
+	.get_frame_number = ehci_get_frame,
+
+	/*
+	 * root hub support
+	 */
+	.hub_status_data = ehci_hub_status_data,
+	.hub_control = ehci_hub_control,
+	.bus_suspend = ehci_bus_suspend,
+	.bus_resume = ehci_bus_resume,
+	.relinquish_port = ehci_relinquish_port,
+	.port_handed_over = ehci_port_handed_over,
+};
+
+/**
+ * usb_hcd_msm7201_remove - shutdown processing for MSM7201-based HCDs
+ * @pdev: USB Host Controller being removed
+ * Context: !in_interrupt()
+ *
+ * Reverses the effect of usb_hcd_msm7201_probe().
+ *
+ */
+static int usb_hcd_msm7201_remove(struct platform_device *pdev)
+{
+	struct usb_hcd *hcd = platform_get_drvdata(pdev);
+	struct msm7201_usb_priv *msm7201 = hcd_to_msm7201(hcd);
+
+	usb_remove_hcd(hcd);
+	msm7201_shutdown_phy(hcd);
+	clk_put(msm7201->clk);
+	clk_put(msm7201->pclk);
+	iounmap(hcd->regs);
+	release_mem_region(hcd->rsrc_start, hcd->rsrc_len);
+	usb_put_hcd(hcd);
+	
+	return 0;
+}
+
+/**
+ * usb_hcd_msm7201_probe - initialize MSM7201-based HCDs
+ * @pdev: USB Host Controller being probed
+ * Context: !in_interrupt()
+ *
+ * Allocates basic resources for this USB host controller.
+ *
+ */
+static int usb_hcd_msm7201_probe(struct platform_device *pdev)
+{
+	struct usb_hcd *hcd;
+	struct resource *res;
+	struct msm7201_usb_priv *msm7201;
+	int irq;
+	int retval;
+	const struct hc_driver *driver = &ehci_msm7201_hc_driver;
+	struct msm_hsusb_platform_data *pdata = pdev->dev.platform_data;
+
+	if (usb_disabled())
+		return -ENODEV;
+
+	pr_debug("initializing MSM7201 USB Controller\n");
+
+	res = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (!res) {
+		dev_err(&pdev->dev,
+			"Found HC with no IRQ. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		return -ENODEV;
+	}
+	irq = res->start;
+
+	hcd = usb_create_hcd(driver, &pdev->dev, dev_name(&pdev->dev));
+	if (!hcd) {
+		retval = -ENOMEM;
+		goto err1;
+	}
+	
+	msm7201 = hcd_to_msm7201(hcd);
+	if (pdata) {
+		msm7201->phy_reset = pdata->phy_reset;
+		msm7201->phy_shutdown = pdata->phy_shutdown;
+		msm7201->phy_init_seq = pdata->phy_init_seq;
+	}
+	
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!res) {
+		dev_err(&pdev->dev,
+			"Found HC with no register addr. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		retval = -ENODEV;
+		goto err2;
+	}
+	hcd->rsrc_start = res->start;
+	hcd->rsrc_len = res->end - res->start + 1;
+	if (!request_mem_region(hcd->rsrc_start, hcd->rsrc_len,
+				driver->description)) {
+		dev_dbg(&pdev->dev, "controller already in use\n");
+		retval = -EBUSY;
+		goto err2;
+	}
+	hcd->regs = ioremap(hcd->rsrc_start, hcd->rsrc_len);
+
+	if (hcd->regs == NULL) {
+		dev_dbg(&pdev->dev, "error mapping memory\n");
+		retval = -EFAULT;
+		goto err3;
+	}
+	
+	msm7201->clk = clk_get(&pdev->dev, "usb_hs_clk");
+	if (IS_ERR(msm7201->clk)) {
+		dev_dbg(&pdev->dev, "error getting usb_hs_clk\n");
+		retval = -EFAULT;
+		goto err4;	  
+	}
+
+	msm7201->pclk = clk_get(&pdev->dev, "usb_hs_pclk");
+	if (IS_ERR(msm7201->pclk)) {
+		dev_dbg(&pdev->dev, "error getting usb_hs_pclk\n");
+		retval = -EFAULT;
+		goto err5;	  
+	}
+
+        clk_enable(msm7201->clk);
+        clk_enable(msm7201->pclk);
+
+        /* wait for a while after enable usb clk*/
+        msleep(5);
+
+	retval = usb_add_hcd(hcd, irq, IRQF_DISABLED | IRQF_SHARED);
+	if (retval != 0)
+		goto err6;
+	return retval;
+
+      err6:
+	clk_put(msm7201->pclk);
+      err5:
+	clk_put(msm7201->clk);
+      err4:
+	iounmap(hcd->regs);	
+      err3:
+	release_mem_region(hcd->rsrc_start, hcd->rsrc_len);
+      err2:
+	usb_put_hcd(hcd);
+      err1:
+	dev_err(&pdev->dev, "init %s fail, %d\n", dev_name(&pdev->dev), retval);
+	return retval;
+}
+
+MODULE_ALIAS("platform:msm_hsusb");
+
+static struct platform_driver ehci_msm7201_driver = {
+	.probe = usb_hcd_msm7201_probe,
+	.remove = usb_hcd_msm7201_remove,
+	.shutdown = usb_hcd_platform_shutdown,
+	.driver = {
+		   .name = "msm_hsusb",
+	},
+};
diff --git a/drivers/usb/host/ehci-msm7201.h b/drivers/usb/host/ehci-msm7201.h
new file mode 100644
index 0000000..b1f67e8
--- /dev/null
+++ b/drivers/usb/host/ehci-msm7201.h
@@ -0,0 +1,88 @@
+/* 
+ * Copyright (c) 2010 Andrew de Quincey
+ *
+ * This program is free software; you can redistribute  it and/or modify it
+ * under  the terms of  the GNU General  Public License as published by the
+ * Free Software Foundation;  either version 2 of the  License, or (at your
+ * option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the  GNU General Public License along
+ * with this program; if not, write  to the Free Software Foundation, Inc.,
+ * 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+#ifndef _EHCI_MSM7201_H
+#define _EHCI_MSM7201_H
+
+struct msm7201_usb_priv 
+{
+	struct clk *clk;
+	struct clk *pclk;
+
+	int *phy_init_seq;
+	void (*phy_reset)(void);
+	void (*phy_shutdown)(void);
+};
+
+static inline struct msm7201_usb_priv *hcd_to_msm7201(struct usb_hcd *hcd)
+{
+	return (struct msm7201_usb_priv *) (((unsigned char*) (hcd->hcd_priv)) + sizeof(struct ehci_hcd));
+}
+
+#define MSM_USB_BASE	     ((unsigned) hcd->regs)
+
+#define USB_ID               (MSM_USB_BASE + 0x0000)
+#define USB_HWGENERAL        (MSM_USB_BASE + 0x0004)
+#define USB_HWHOST           (MSM_USB_BASE + 0x0008)
+#define USB_HWDEVICE         (MSM_USB_BASE + 0x000C)
+#define USB_HWTXBUF          (MSM_USB_BASE + 0x0010)
+#define USB_HWRXBUF          (MSM_USB_BASE + 0x0014)
+#define USB_SBUSCFG          (MSM_USB_BASE + 0x0090)
+
+#define USB_CAPLENGTH        (MSM_USB_BASE + 0x0100) /* 8 bit */
+#define USB_HCIVERSION       (MSM_USB_BASE + 0x0102) /* 16 bit */
+#define USB_HCSPARAMS        (MSM_USB_BASE + 0x0104)
+#define USB_HCCPARAMS        (MSM_USB_BASE + 0x0108)
+#define USB_DCIVERSION       (MSM_USB_BASE + 0x0120) /* 16 bit */
+#define USB_USBCMD           (MSM_USB_BASE + 0x0140)
+#define USB_USBSTS           (MSM_USB_BASE + 0x0144)
+#define USB_USBINTR          (MSM_USB_BASE + 0x0148)
+#define USB_FRINDEX          (MSM_USB_BASE + 0x014C)
+#define USB_DEVICEADDR       (MSM_USB_BASE + 0x0154)
+#define USB_ENDPOINTLISTADDR (MSM_USB_BASE + 0x0158)
+#define USB_BURSTSIZE        (MSM_USB_BASE + 0x0160)
+#define USB_TXFILLTUNING     (MSM_USB_BASE + 0x0164)
+#define USB_ULPI_VIEWPORT    (MSM_USB_BASE + 0x0170)
+#define USB_ENDPTNAK         (MSM_USB_BASE + 0x0178)
+#define USB_ENDPTNAKEN       (MSM_USB_BASE + 0x017C)
+#define USB_PORTSC           (MSM_USB_BASE + 0x0184)
+#define USB_OTGSC            (MSM_USB_BASE + 0x01A4)
+#define USB_USBMODE          (MSM_USB_BASE + 0x01A8)
+#define USB_ENDPTSETUPSTAT   (MSM_USB_BASE + 0x01AC)
+#define USB_ENDPTPRIME       (MSM_USB_BASE + 0x01B0)
+#define USB_ENDPTFLUSH       (MSM_USB_BASE + 0x01B4)
+#define USB_ENDPTSTAT        (MSM_USB_BASE + 0x01B8)
+#define USB_ENDPTCOMPLETE    (MSM_USB_BASE + 0x01BC)
+#define USB_ENDPTCTRL(n)     (MSM_USB_BASE + 0x01C0 + (4 * (n)))
+
+#define USBCMD_RESET   2
+#define USBCMD_ATTACH  1
+#define USBCMD_ATDTW   (1 << 14)
+
+#define USBMODE_DEVICE 2
+#define USBMODE_HOST   3
+
+#define ULPI_WAKEUP           (1 << 31)
+#define ULPI_RUN              (1 << 30)
+#define ULPI_WRITE            (1 << 29)
+#define ULPI_READ             (0 << 29)
+#define ULPI_STATE_NORMAL     (1 << 27)
+#define ULPI_ADDR(n)          (((n) & 255) << 16)
+#define ULPI_DATA(n)          ((n) & 255)
+#define ULPI_DATA_READ(n)     (((n) >> 8) & 255)
+
+#endif				/* _EHCI_MSM7201_H */
